=== modified file 'lisp/progmodes/sql.el'
--- old/lisp/progmodes/sql.el	2010-01-13 08:35:10 +0000
+++ new/lisp/progmodes/sql.el	2010-04-16 03:07:36 +0000
@@ -5,7 +5,7 @@
 
 ;; Author: Alex Schroeder <alex@gnu.org>
 ;; Maintainer: Michael Mauger <mmaug@yahoo.com>
-;; Version: 2.0.2
+;; Version: 2.1
 ;; Keywords: comm languages processes
 ;; URL: http://savannah.gnu.org/cgi-bin/viewcvs/emacs/emacs/lisp/progmodes/sql.el
 ;; URL: http://www.emacswiki.org/cgi-bin/wiki.pl?SqlMode
@@ -103,83 +103,73 @@
 ;; identifiers; ms (Microsoft SQLServer) also supports identifiers
 ;; enclosed within brackets [].
 
-;; ChangeLog available on request.
-
 ;;; Product Support:
 
 ;; To add support for additional SQL products the following steps
 ;; must be followed ("xyz" is the name of the product in the examples
 ;; below):
 
-;; 1) Add the product to `sql-product' choice list.
-
-;;     (const :tag "XyzDB" xyz)
-
-;; 2) Add an entry to the `sql-product-alist' list.
-
-;;     (xyz
-;;      :font-lock sql-mode-xyz-font-lock-keywords
-;;      :sqli-login (user password server database)
-;;      :sqli-connect sql-connect-xyz
-;;      :sqli-prompt-regexp "^xyzdb> "
-;;      :sqli-prompt-length 7
-;;      :sqli-input-sender nil
-;;      :syntax-alist ((?# . "w")))
-
-;; 3) Add customizable values for the product interpreter and options.
-
-;;     ;; Customization for XyzDB
-;;
-;;     (defcustom sql-xyz-program "ixyz"
-;;       "*Command to start ixyz by XyzDB."
+;; 1) Add the product to the list of known products.
+
+;;     (sql-add-product 'xyz "XyzDB"
+;;     	                '(:free-software t))
+
+;; 2) Define font lock settings.  All ANSI keywords will be
+;;    highlighted automatically, so only product specific keywords
+;;    need to be defined here.
+
+;;     (defvar my-sql-mode-xyz-font-lock-keywords
+;;       '(("\\b\\(red\\|orange\\|yellow\\)\\b"
+;;          . font-lock-keyword-face))
+;;       "XyzDB SQL keywords used by font-lock.")
+
+;;     (sql-set-product-feature 'xyz
+;;                              :font-lock
+;;                              'my-sql-mode-xyz-font-lock-keywords)
+
+;; 3) Define any special syntax characters including comments and
+;;    identifier characters.
+
+;;     (sql-set-product-feature 'xyz
+;;                              :syntax-alist ((?# . "w")))
+
+;; 4) Define the interactive command interpreter for the database
+;;    product.
+
+;;     (defcustom my-sql-xyz-program "ixyz"
+;;       "Command to start ixyz by XyzDB."
 ;;       :type 'file
 ;;       :group 'SQL)
-;;
-;;     (defcustom sql-xyz-options '("-X" "-Y" "-Z")
-;;       "*List of additional options for `sql-xyz-program'."
+
+;;     (sql-set-product-feature 'xyz
+;;                              :sql-program 'my-sql-xyz-program)
+;;     (sql-set-product-feature 'xyz
+;;                              :sqli-prompt-regexp "^xyzdb> ")
+;;     (sql-set-product-feature 'xyz
+;;                              :sqli-prompt-length 7)
+
+;; 5) Define login parameters and command line formatting.
+
+;;     (defcustom my-sql-xyz-login-params '(user password server database)
+;;       "Login parameters to needed to connect to XyzDB."
+;;       :type '(repeat (choice
+;;                        (const user)
+;;                        (const password)
+;;                        (const server)
+;;                        (const database)))
+;;       :group 'SQL)
+
+;;     (defcustom my-sql-xyz-options '("-X" "-Y" "-Z")
+;;       "List of additional options for `sql-xyz-program'."
 ;;       :type '(repeat string)
 ;;       :group 'SQL)
 
-;; 4) Add an entry to SQL->Product submenu.
-
-;;     ["XyzDB" sql-highlight-xyz-keywords
-;;      :style radio
-;;      :selected (eq sql-product 'xyz)]
-
-;; 5) Add the font-lock specifications.  At a minimum, default to
-;;    using ANSI keywords.  See sql-mode-oracle-font-lock-keywords for
-;;    a more complex example.
-
-;;     (defvar sql-mode-xyz-font-lock-keywords nil
-;;       "XyzDB SQL keywords used by font-lock.")
-
-;; 6) Add a product highlighting function.
-
-;;     (defun sql-highlight-xyz-keywords ()
-;;       "Highlight XyzDB keywords."
-;;       (interactive)
-;;       (sql-set-product 'xyz))
-
-;; 7) Add an autoloaded SQLi function.
-
-;;     ;;;###autoload
-;;     (defun sql-xyz ()
-;;       "Run ixyz by XyzDB as an inferior process."
-;;       (interactive)
-;;       (sql-product-interactive 'xyz))
-
-;; 8) Add a connect function which formats the command line arguments
-;;    and starts the product interpreter in a comint buffer.  See the
-;;    existing connect functions for examples of the types of
-;;    processing available.
-
-;;     (defun sql-connect-xyz ()
-;;       "Create comint buffer and connect to XyzDB using the login
-;;     parameters and command options."
+;;     (defun my-sql-connect-xyz ()
+;;       "Connect ti XyzDB in a comint buffer."
 ;;
 ;;         ;; Do something with `sql-user', `sql-password',
 ;;         ;; `sql-database', and `sql-server'.
-;;         (let ((params sql-xyz-options))
+;;         (let ((params my-sql-xyz-options))
 ;;           (if (not (string= "" sql-server))
 ;;              (setq params (append (list "-S" sql-server) params)))
 ;;           (if (not (string= "" sql-database))
@@ -188,25 +178,38 @@
 ;;               (setq params (append (list "-P" sql-password) params)))
 ;;           (if (not (string= "" sql-user))
 ;;               (setq params (append (list "-U" sql-user) params)))
-;;           (set-buffer (apply 'make-comint "SQL" sql-xyz-program
-;;                              nil params))))
-
-;; 9) Save and compile sql.el.
+;;           (sql-connect-1 my-sql-xyz-program params)))
+
+;;     (sql-set-product-feature 'xyz
+;;                              :sqli-login 'my-sql-xyz-login-params)
+;;     (sql-set-product-feature 'xyz
+;;                              :sqli-connect 'my-sql-connect-xyz)
+
+;; 6) Define a convienence function to invoke the SQL interpreter.
+
+;;     (defun my-sql-xyz ()
+;;       "Run ixyz by XyzDB as an inferior process."
+;;       (interactive)
+;;       (sql-product-interactive 'xyz))
 
 ;;; To Do:
 
-;; Add better hilight support for other brands; there is a bias towards
-;; Oracle because that's what I use at work.  Anybody else just send in
-;; your lists of reserved words, keywords and builtin functions!  As
-;; long as I don't receive any feedback, everything is hilighted with
-;; ANSI keywords only.  I received the list of ANSI keywords from a
-;; user; if you know of any changes, let me know.
-
-;; Add different hilighting levels.
+;; Improve keyword highlighting for individual products.  I have tried
+;; to update those database that I use.  Feel free to send me updates,
+;; or direct me to the reference manuals for your favorite database.
+
+;; When there are no keywords defined, the ANSI keywords are
+;; highlighted.  ANSI keywords are highlighted even if the keyword is
+;; not used for your current product.  This should help identify
+;; portability concerns.
+
+;; Add different highlighting levels.
+
+;; Add support for listing available tables or the columns in a table.
 
 ;;; Thanks to all the people who helped me out:
 
-;; Alex Schroeder <alex@gnu.org>
+;; Alex Schroeder <alex@gnu.org> -- the original author
 ;; Kai Blauberg <kai.blauberg@metla.fi>
 ;; <ibalaban@dalet.com>
 ;; Yair Friedman <yfriedma@JohnBryce.Co.Il>
@@ -217,7 +220,7 @@
 ;; Michael Mauger <mmaug@yahoo.com> -- improved product support
 ;; Drew Adams <drew.adams@oracle.com> -- Emacs 20 support
 ;; Harald Maier <maierh@myself.com> -- sql-send-string
-;; Stefan Monnier <monnier@iro.umontreal.ca> -- font-lock corrections
+;; Stefan Monnier <monnier@iro.umontreal.ca> -- font-lock corrections; code polish
 
 
 
@@ -240,32 +243,43 @@
 (defgroup SQL nil
   "Running a SQL interpreter from within Emacs buffers."
   :version "20.4"
+  :group 'languages
   :group 'processes)
 
 ;; These four variables will be used as defaults, if set.
 
 (defcustom sql-user ""
-  "*Default username."
+  "Default username."
   :type 'string
   :group 'SQL)
+(put 'sql-user 'safe-local-variable 'stringp)
 
 (defcustom sql-password ""
-  "*Default password.
+  "Default password.
 
 Storing your password in a textfile such as ~/.emacs could be dangerous.
 Customizing your password will store it in your ~/.emacs file."
   :type 'string
   :group 'SQL)
+(put 'sql-password 'risky-local-variable t)
 
 (defcustom sql-database ""
-  "*Default database."
+  "Default database."
   :type 'string
   :group 'SQL)
+(put 'sql-database 'safe-local-variable 'stringp)
 
 (defcustom sql-server ""
+  "Default server or host."
+  :type 'string
+  :group 'SQL)
+(put 'sql-server 'safe-local-variable 'stringp)
+
+(defcustom sql-port nil
   "*Default server or host."
-  :type 'string
+  :type 'number
   :group 'SQL)
+(put 'sql-port 'safe-local-variable 'numberp)
 
 ;; SQL Product support
 
@@ -274,110 +288,163 @@
 
 (defvar sql-product-alist
   '((ansi
-     :name "ANSI"
+     :display "ANSI"
      :font-lock sql-mode-ansi-font-lock-keywords)
+
     (db2
-     :name "DB2"
+     :display "DB2"
      :font-lock sql-mode-db2-font-lock-keywords
-     :sqli-login nil
+     :sql-program sql-db2-program
+     :sqli-login sql-db2-login-params
      :sqli-connect sql-connect-db2
      :sqli-prompt-regexp "^db2 => "
-     :sqli-prompt-length 7)
+     :sqli-prompt-length 7
+     :sqli-input-filter sql-escape-newlines-filter)
+
     (informix
+     :display "Informix"
      :font-lock sql-mode-informix-font-lock-keywords
-     :sqli-login (database)
+     :sql-program sql-informix-program
+     :sqli-login sql-informix-login-params
      :sqli-connect sql-connect-informix
-     :sqli-prompt-regexp "^SQL> "
-     :sqli-prompt-length 5)
+     :sqli-prompt-regexp "^> "
+     :sqli-prompt-length 2
+     :syntax-alist ((?{ . "<") (?} . ">")))
+
     (ingres
+     :display "Ingres"
      :font-lock sql-mode-ingres-font-lock-keywords
-     :sqli-login (database)
+     :sql-program sql-ingres-program
+     :sqli-login sql-ingres-login-params
      :sqli-connect sql-connect-ingres
      :sqli-prompt-regexp "^\* "
      :sqli-prompt-length 2)
+
     (interbase
+     :display "Interbase"
      :font-lock sql-mode-interbase-font-lock-keywords
-     :sqli-login (user password database)
+     :sql-program sql-interbase-program
+     :sqli-login sql-interbase-login-params
      :sqli-connect sql-connect-interbase
      :sqli-prompt-regexp "^SQL> "
      :sqli-prompt-length 5)
+
     (linter
+     :display "Linter"
      :font-lock sql-mode-linter-font-lock-keywords
-     :sqli-login (user password database server)
+     :sql-program sql-linter-program
+     :sqli-login sql-linter-login-params
      :sqli-connect sql-connect-linter
      :sqli-prompt-regexp "^SQL>"
      :sqli-prompt-length 4)
+
     (ms
-     :name "MS SQLServer"
+     :display "Microsoft"
      :font-lock sql-mode-ms-font-lock-keywords
-     :sqli-login (user password server database)
+     :sql-program sql-ms-program
+     :sqli-login sql-ms-login-params
      :sqli-connect sql-connect-ms
      :sqli-prompt-regexp "^[0-9]*>"
      :sqli-prompt-length 5
-     :syntax-alist ((?@ . "w")))
+     :syntax-alist ((?@ . "w"))
+     :sql-send-terminator ("^go" . "go"))
+
     (mysql
-     :name "MySQL"
+     :display "MySQL"
+     :free-software t
      :font-lock sql-mode-mysql-font-lock-keywords
-     :sqli-login (user password database server)
+     :sql-program sql-mysql-program
+     :sqli-login sql-mysql-login-params
      :sqli-connect sql-connect-mysql
      :sqli-prompt-regexp "^mysql> "
-     :sqli-prompt-length 6)
+     :sqli-prompt-length 6
+     :sql-input-filter sql-remove-tabs-filter)
+
     (oracle
+     :display "Oracle"
      :font-lock sql-mode-oracle-font-lock-keywords
-     :sqli-login (user password database)
+     :sql-program sql-oracle-program
+     :sqli-login sql-oracle-login-params
      :sqli-connect sql-connect-oracle
      :sqli-prompt-regexp "^SQL> "
      :sqli-prompt-length 5
-     :syntax-alist ((?$ . "w") (?# . "w")))
+     :syntax-alist ((?$ . "w") (?# . "w"))
+     :sql-send-terminator ("\\(^/\\|;\\)" . "/")
+     :sqli-input-filter sql-placeholders-filter)
+
     (postgres
+     :display "Postgres"
+     :free-software t
      :font-lock sql-mode-postgres-font-lock-keywords
-     :sqli-login (user database server)
+     :sql-program sql-postgres-program
+     :sqli-login sql-postgres-login-params
      :sqli-connect sql-connect-postgres
      :sqli-prompt-regexp "^.*[#>] *"
-     :sqli-prompt-length 5)
+     :sqli-prompt-length 5
+     :sql-input-filter sql-remove-tabs-filter
+     :sql-send-terminator ("\\(^[\\]g\\|;\\)" . ";"))
+
     (solid
+     :display "Solid"
      :font-lock sql-mode-solid-font-lock-keywords
-     :sqli-login (user password server)
+     :sql-program sql-solid-program
+     :sqli-login sql-solid-login-params
      :sqli-connect sql-connect-solid
      :sqli-prompt-regexp "^"
      :sqli-prompt-length 0)
+
     (sqlite
-     :name "SQLite"
+     :display "SQLite"
+     :free-software t
      :font-lock sql-mode-sqlite-font-lock-keywords
-     :sqli-login (database)
+     :sql-program sql-sqlite-program
+     :sqli-login sql-sqlite-login-params
      :sqli-connect sql-connect-sqlite
      :sqli-prompt-regexp "^sqlite> "
      :sqli-prompt-length 8)
+
     (sybase
+     :display "Sybase"
      :font-lock sql-mode-sybase-font-lock-keywords
-     :sqli-login (server user password database)
+     :sql-program sql-sybase-program
+     :sqli-login sql-sybase-login-params
      :sqli-connect sql-connect-sybase
      :sqli-prompt-regexp "^SQL> "
      :sqli-prompt-length 5
-     :syntax-alist ((?@ . "w")))
+     :syntax-alist ((?@ . "w"))
+     :sql-send-terminator ("^go" . "go"))
     )
-  "This variable contains a list of product features for each of the
-SQL products handled by `sql-mode'.  Without an entry in this list a
-product will not be properly highlighted and will not support
-`sql-interactive-mode'.
+  "An alist of product specific configuration settings.
+
+Without an entry in this list a product will not be properly
+highlighted and will not support `sql-interactive-mode'.
 
 Each element in the list is in the following format:
 
  \(PRODUCT FEATURE VALUE ...)
 
-where PRODUCT is the appropriate value of `sql-product'.  The product
-name is then followed by FEATURE-VALUE pairs.  If a FEATURE is not
-specified, its VALUE is treated as nil.  FEATURE must be one of the
-following:
+where PRODUCT is the appropriate value of `sql-product'.  The
+product name is then followed by FEATURE-VALUE pairs.  If a
+FEATURE is not specified, its VALUE is treated as nil.  FEATURE
+may be any one of the following:
+
+ :display               string containing the displayable name of
+                        the product.
+
+ :free-software         is the product Free (as in Freedom) software?
 
  :font-lock             name of the variable containing the product
                         specific font lock highlighting patterns.
 
- :sqli-login            a list of login parameters (i.e., user,
-                        password, database and server) needed to
-                        connect to the database.
-
- :sqli-connect          the name of a function which accepts no
+ :sql-program           name of the variable containing the product
+                        specific interactive program name.
+
+ :sqli-login            name of the variable containing the list of
+                        login parameters (i.e., user, password,
+                        database and server) needed to connect to
+                        the database.
+
+ :sqli-connect          name of a function which accepts no
                         parameters that will use the values of
                         `sql-user', `sql-password',
                         `sql-database' and `sql-server' to open a
@@ -385,30 +452,57 @@
                         database.  Do product specific
                         configuration of comint in this function.
 
- :sqli-prompt-regexp    a regular expression string that matches
+ :sqli-prompt-regexp    regular expression string that matches
                         the prompt issued by the product
-                        interpreter.  (Not needed in 21.3+)
-
- :sqli-prompt-length    the length of the prompt on the line.(Not
-                        needed in 21.3+)
-
- :syntax-alist          an alist of syntax table entries to enable
-                        special character treatment by font-lock and
-                        imenu. ")
-
+                        interpreter.
+
+ :sqli-prompt-length    length of the prompt on the line.
+
+ :sql-input-filter      function which can filter strings sent to
+                        the command interpreter.  It is also used
+                        by the `sql-send-string',
+                        `sql-send-region', `sql-send-paragraph'
+                        and `sql-send-buffer' functions.  The
+                        function is passed the string sent to the
+                        command interpreter and must return the
+                        filtered string.
+
+ :sql-send-terminator   the terminator to be sent after a
+                        `sql-send-string', `sql-send-region',
+                        `sql-send-paragraph' and
+                        `sql-send-buffer' command.  May be the
+                        literal string or a cons of a regexp to
+                        match an existing terminator in the
+                        string and the terminator to be used if
+                        its absent.  By default \";\".
+
+ :syntax-alist          alist of syntax table entries to enable
+                        special character treatment by font-lock
+                        and imenu.
+
+Other features can be stored but they will be ignored.  However,
+you can develop new functionality which is product independent by
+using `sql-get-product-feature' to lookup the product specific
+settings.")
+
+;;;###autoload
 (defcustom sql-product 'ansi
   "*Select the SQL database product used so that buffers can be
 highlighted properly when you open them."
   :type `(choice
           ,@(mapcar (lambda (prod-info)
                       `(const :tag
-                              ,(or (plist-get (cdr prod-info) :name)
+                              ,(or (plist-get (cdr prod-info) :display)
                                    (capitalize (symbol-name (car prod-info))))
                               ,(car prod-info)))
                     sql-product-alist))
   :group 'SQL)
-
-;; misc customization of sql.el behavior
+(put 'sql-product 'safe-local-variable 'symbolp)
+
+(defvar sql-interactive-product nil
+  "Product under `sql-interactive-mode'.")
+
+;; misc customization of sql.el behaviour
 
 (defcustom sql-electric-stuff nil
   "Treat some input as electric.
@@ -424,14 +518,44 @@
   :version "20.8"
   :group 'SQL)
 
+(defcustom sql-send-terminator nil
+  "When non-nil, add a terminator to text sent to the SQL interpreter.
+
+When text is sent to the SQL interpreter (via `sql-send-string',
+`sql-send-region', `sql-send-paragraph' or `sql-send-buffer'), a
+command terminator can be automatically sent as well.  The
+terminator is not sent, if the string sent already ends with the
+terminator.
+
+If this value is t, then the default command terminator for the
+SQL interpreter is sent.  If this value is a string, then the
+string is sent.
+
+If the value is a cons cell of the form (PAT . TERM), then PAT is
+a regexp used to match the terminator in the string and TERM is
+the terminator to be sent.  This form is useful if the SQL
+interpreter has more than one way of submitting a SQL command.
+The PAT regexp can match any of them, and TERM is the way we do
+it automatically."
+
+  :type '(choice (const  :tag "No Terminator" nil)
+		 (const  :tag "Default Terminator" t)
+		 (string :tag "Terminator String")
+		 (cons   :tag "Terminator Pattern and String"
+			 (string :tag "Terminator Pattern")
+			 (string :tag "Terminator String")))
+  :version "22.2"
+  :group 'SQL)
+
 (defcustom sql-pop-to-buffer-after-send-region nil
-  "*If t, pop to the buffer SQL statements are sent to.
+  "When non-nil, pop to the buffer SQL statements are sent to.
 
-After a call to `sql-send-region' or `sql-send-buffer',
-the window is split and the SQLi buffer is shown.  If this
-variable is not nil, that buffer's window will be selected
-by calling `pop-to-buffer'.  If this variable is nil, that
-buffer is shown using `display-buffer'."
+After a call to `sql-sent-string', `sql-send-region',
+`sql-send-paragraph' or `sql-send-buffer', the window is split
+and the SQLi buffer is shown.  If this variable is not nil, that
+buffer's window will be selected by calling `pop-to-buffer'.  If
+this variable is nil, that buffer is shown using
+`display-buffer'."
   :type 'boolean
   :group 'SQL)
 
@@ -445,19 +569,20 @@
     ("Functions" "^\\s-*\\(create\\s-+\\(\\w+\\s-+\\)*\\)?function\\s-+\\(\\w+\\)" 3)
     ("Procedures" "^\\s-*\\(create\\s-+\\(\\w+\\s-+\\)*\\)?proc\\(edure\\)?\\s-+\\(\\w+\\)" 4)
     ("Packages" "^\\s-*create\\s-+\\(\\w+\\s-+\\)*package\\s-+\\(body\\s-+\\)?\\(\\w+\\)" 3)
+    ("Types" "^\\s-*create\\s-+\\(\\w+\\s-+\\)*type\\s-+\\(body\\s-+\\)?\\(\\w+\\)" 3)
     ("Indexes" "^\\s-*create\\s-+\\(\\w+\\s-+\\)*index\\s-+\\(\\w+\\)" 2)
     ("Tables/Views" "^\\s-*create\\s-+\\(\\w+\\s-+\\)*\\(table\\|view\\)\\s-+\\(\\w+\\)" 3))
   "Define interesting points in the SQL buffer for `imenu'.
 
 This is used to set `imenu-generic-expression' when SQL mode is
-entered.  Subsequent changes to sql-imenu-generic-expression will not
-affect existing SQL buffers because imenu-generic-expression is a
+entered.  Subsequent changes to `sql-imenu-generic-expression' will not
+affect existing SQL buffers because `imenu-generic-expression' is a
 local variable.")
 
 ;; history file
 
 (defcustom sql-input-ring-file-name nil
-  "*If non-nil, name of the file to read/write input history.
+  "If non-nil, name of the file to read/write input history.
 
 You have to set this variable if you want the history of your commands
 saved from one Emacs session to the next.  If this variable is set,
@@ -474,7 +599,7 @@
   :group 'SQL)
 
 (defcustom sql-input-ring-separator "\n--\n"
-  "*Separator between commands in the history file.
+  "Separator between commands in the history file.
 
 If set to \"\\n\", each line in the history file will be interpreted as
 one command.  Multi-line commands are split into several commands when
@@ -492,19 +617,19 @@
 ;; The usual hooks
 
 (defcustom sql-interactive-mode-hook '()
-  "*Hook for customizing `sql-interactive-mode'."
+  "Hook for customizing `sql-interactive-mode'."
   :type 'hook
   :group 'SQL)
 
 (defcustom sql-mode-hook '()
-  "*Hook for customizing `sql-mode'."
+  "Hook for customizing `sql-mode'."
   :type 'hook
   :group 'SQL)
 
 (defcustom sql-set-sqli-hook '()
-  "*Hook for reacting to changes of `sql-buffer'.
+  "Hook for reacting to changes of `sqli-buffer'.
 
-This is called by `sql-set-sqli-buffer' when the value of `sql-buffer'
+This is called by `sql-set-sqli-buffer' when the value of `sqli-buffer'
 is changed."
   :type 'hook
   :group 'SQL)
@@ -512,144 +637,222 @@
 ;; Customization for Oracle
 
 (defcustom sql-oracle-program "sqlplus"
-  "*Command to start sqlplus by Oracle.
+  "Command to start sqlplus by Oracle.
 
 Starts `sql-interactive-mode' after doing some setup.
 
 Under NT, \"sqlplus\" usually starts the sqlplus \"GUI\".  In order to
 start the sqlplus console, use \"plus33\" or something similar.  You
-will find the file in your Orant\\bin directory.
-
-The program can also specify a TCP connection.  See `make-comint'."
+will find the file in your Orant\\bin directory."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-oracle-options nil
-  "*List of additional options for `sql-oracle-program'."
+  "List of additional options for `sql-oracle-program'."
   :type '(repeat string)
   :version "20.8"
   :group 'SQL)
 
+(defcustom sql-oracle-login-params '(user password database)
+  "List of login parameters needed to connect to Oracle."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
+(defcustom sql-oracle-scan-on t
+  "Non-nil if placeholders should be replaced in Oracle SQLi.
+
+When non-nil, Emacs will scan text sent to sqlplus and prompt
+for replacement text for & placeholders as sqlplus does.  This
+is needed on Windows where sqlplus output is buffer and the
+prompts are not shown until after the text is entered.
+
+You will probably want to issue the following command in sqlplus
+to be safe:
+
+    SET SCAN OFF"
+  :type 'boolean
+  :group 'SQL)
+
 ;; Customization for SQLite
 
 (defcustom sql-sqlite-program "sqlite"
-  "*Command to start SQLite.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start SQLite.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-sqlite-options nil
-  "*List of additional options for `sql-sqlite-program'.
+  "List of additional options for `sql-sqlite-program'.
+
 The following list of options is reported to make things work
 on Windows: \"-C\" \"-t\" \"-f\" \"-n\"."
   :type '(repeat string)
   :version "20.8"
   :group 'SQL)
 
+(defcustom sql-sqlite-login-params '(user password server database)
+  "List of login parameters needed to connect to Oracle."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for MySql
 
 (defcustom sql-mysql-program "mysql"
-  "*Command to start mysql by TcX.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start mysql by TcX.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-mysql-options nil
-  "*List of additional options for `sql-mysql-program'.
+  "List of additional options for `sql-mysql-program'.
 The following list of options is reported to make things work
 on Windows: \"-C\" \"-t\" \"-f\" \"-n\"."
   :type '(repeat string)
   :version "20.8"
   :group 'SQL)
 
+(defcustom sql-mysql-login-params '(user password database server)
+  "List of login parameters needed to connect to MySql."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for Solid
 
 (defcustom sql-solid-program "solsql"
-  "*Command to start SOLID SQL Editor.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start SOLID SQL Editor.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
+(defcustom sql-solid-login-params '(user password server)
+  "List of login parameters needed to connect to Solid."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for SyBase
 
 (defcustom sql-sybase-program "isql"
-  "*Command to start isql by SyBase.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start isql by SyBase.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-sybase-options nil
-  "*List of additional options for `sql-sybase-program'.
+  "List of additional options for `sql-sybase-program'.
 Some versions of isql might require the -n option in order to work."
   :type '(repeat string)
   :version "20.8"
   :group 'SQL)
 
+(defcustom sql-sybase-login-params '(server user password database)
+  "List of login parameters needed to connect to Sybase."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for Informix
 
 (defcustom sql-informix-program "dbaccess"
-  "*Command to start dbaccess by Informix.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start dbaccess by Informix.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
+(defcustom sql-informix-login-params '(database)
+  "List of login parameters needed to connect to Informix."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for Ingres
 
 (defcustom sql-ingres-program "sql"
-  "*Command to start sql by Ingres.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start sql by Ingres.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
+(defcustom sql-ingres-login-params '(database)
+  "List of login parameters needed to connect to Ingres."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for Microsoft
 
 (defcustom sql-ms-program "osql"
-  "*Command to start osql by Microsoft.
-
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+  "Command to start osql by Microsoft.
+
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-ms-options '("-w" "300" "-n")
   ;; -w is the linesize
-  "*List of additional options for `sql-ms-program'."
+  "List of additional options for `sql-ms-program'."
   :type '(repeat string)
   :version "22.1"
   :group 'SQL)
 
+(defcustom sql-ms-login-params '(user password server database)
+  "List of login parameters needed to connect to Microsoft."
+  :type '(repeat (choice
+		  (const user)
+		  (const password)
+		  (const server)
+		  (const database)))
+  :version "24.1"
+  :group 'SQL)
+
 ;; Customization for Postgres
 
 (defcustom sql-postgres-program "psql"
   "Command to start psql by Postgres.
 
-Starts `sql-interactive-mode' after doing some setup.
-
-The program can also specify a TCP connection.  See `make-comint'."
+Starts `sql-interactive-mode' after doing some setup."
   :type 'file
   :group 'SQL)
 
 (defcustom sql-postgres-options '("-P" "pager=off")
-  "*List of additional options for `sql-postgres-program'.
+  "List of additional options for `sql-postgres-program'.
 The default setting includes the -P option which breaks older versions
 of the psql client (such as version 6.5.3).  The -P option is equivalent
 to the --pset option.  If you want the psql to prompt you for a user
